part of xwidgetbase;

class XfxElencoItem extends StatefulWidget {
  XfxElencoItem({
    Key? key,
    this.childMain,
    this.childDetails,
    this.showingDetails = false,
    this.showMainWithDetails = true,
    this.decorationBackGroundContainer,
    this.changeStatoWithTap = true,
    this.onTapItem,
    this.onLongTapItem,
    this.onDoubleTapItem,
    this.margin,
    this.crossAxisAlignment,
    this.backGroundColor_ChildMain,
    this.colorIcon_Collapsed,
    this.colorIcon_Expanded,
    this.colorText_Collapsed,
    this.colorText_Expanded,
    this.showTrailingArrow = true,
    this.icon_Active,
    this.icon_Disabled,
  }) : super(key: key);

  /// default TRUE
  bool showMainWithDetails;
  Widget? childMain;
  bool showingDetails;
  Widget? childDetails;
  bool? changeStatoWithTap;
  bool? showTrailingArrow;
  Color? backGroundColor_ChildMain;
  Color? colorIcon_Expanded;
  Color? colorIcon_Collapsed;
  Color? colorText_Expanded;
  Color? colorText_Collapsed;
  Decoration? decorationBackGroundContainer;
  EdgeInsetsGeometry? margin;
  CrossAxisAlignment? crossAxisAlignment;
  IconData? icon_Active;
  IconData? icon_Disabled;
  Function()? onTapItem;
  Function()? onLongTapItem;
  Function()? onDoubleTapItem;
  @override
  _XfxElencoItemState createState() => _XfxElencoItemState();
}

class _XfxElencoItemState extends State<XfxElencoItem> {
  Widget xBuilder_childMain() {
    return widget.childMain ?? Container();
  }

  @override
  Widget build(BuildContext context) {
    return GestureDetector(
        onTap: widget.onTapItem ??
            () {
              if (widget.changeStatoWithTap == true) {
                setState(() {
                  widget.showingDetails = !widget.showingDetails;
                });
              }
            },
        onLongPress: widget.onLongTapItem ?? () {},
        onDoubleTap: widget.onDoubleTapItem ?? () {},
        child: Container(
            decoration: widget.decorationBackGroundContainer ?? BoxDecoration(color: Colors.grey[900]),
            margin: widget.margin ?? EdgeInsets.only(bottom: 2),
            child: Column(crossAxisAlignment: widget.crossAxisAlignment ?? CrossAxisAlignment.center, children: [
              (widget.showMainWithDetails == false && widget.showingDetails == true)
                  ? Container()
                  : Container(
                      padding: EdgeInsets.all(5),
                      color: widget.backGroundColor_ChildMain,
                      child: Row(children: [
                        Expanded(
                          child: xBuilder_childMain(),
                        ),
                        (widget.changeStatoWithTap != null && widget.changeStatoWithTap == true && widget.showTrailingArrow == true)
                            ? Icon(
                                widget.showingDetails ? widget.icon_Active ?? Icons.keyboard_arrow_up_outlined : widget.icon_Disabled ?? Icons.keyboard_arrow_down_outlined,
                                color: (widget.showingDetails == false) ? widget.colorIcon_Collapsed ?? Colors.grey : widget.colorIcon_Expanded ?? Colors.yellow,
                                size: 28,
                              )
                            : Container()
                      ])),
              Column(children: [
                ((widget.showingDetails == true) ? widget.childDetails! : Container()),
              ]),
            ])));
  }
}
